#!/bin/bash
# ower:zhaoxi@zhizhangyi.com
# 判断是否传入参数
function check_usage(){
	if [ -z "$1" ]; then
    		echo "usage: $0 {mbs|sdp}"
    		exit 1
	fi
}
#判断哪个用户版本
function check_user(){
	case $1 in 
	mbs)
		user_name=mbs
		user_id=2001
		THIRD_DIR=/opt
		echo "V5.0.0~V5.2.1 回复1"
		echo "V5.2.2~V5.3.0 回复2"
		echo "V5.3.1+       回复3"
		read -p "Please enter your choice: " version
	;;
	sdp)
		user_name=sdp
        	user_id=2002
		THIRD_DIR=/opt
		PRODUCT_SDP_DIR=/home/sdp/usdp
		echo "V5.0.0~V5.2.4 回复1"
         	echo "V5.3.0        回复2"
         	echo "V5.3.1+       回复3"
		read -p "Please enter your choice: " version
	;;	
	*)
		echo "usage : $0 {mbs|sdp}"
		exit 1
	esac
}
# 判断操作系统
function check_os(){
	os_name=$(awk -F'=' '/^ID=/{gsub(/"/, "", $2); print $2}' /etc/os-release)
	echo "当前操作系统为$os_name"
	if [[ "$os_name" == "kylin" || "$os_name" == "uos" || "$os_name" == "openEuler" ]]; then
    		echo "$user_name" >> /etc/cron.allow
	fi
}
# 定义创建用户函数
function create_user(){
	groupadd -g ${user_id} ${user_name} &>/dev/null
	useradd -u ${user_id} -g ${user_name} -m -s /bin/bash ${user_name} &>/dev/null
	ssh_pwd=$(< /dev/urandom tr -dc _A-Z-a-z-0-9 | head -c${1:-12};echo;)
	echo ${ssh_pwd} > pass.txt
	echo ${ssh_pwd} | passwd --stdin ${user_name} &>/dev/null
}
# 定义免密
function mbs_ssh(){
	case $version in 
	1)	
		cmd_str="/usr/sbin/iptables,/usr/sbin/gluster,/usr/sbin/exportfs,/usr/sbin/showmount,/usr/bin/mount,/usr/bin/su,\
/usr/bin/umount,/usr/bin/systemctl,/usr/bin/sed,/usr/bin/tee,/usr/bin/vi,/usr/bin/mkdir,/usr/bin/cp,\
/usr/bin/rm,/usr/bin/chown,/usr/bin/chmod,/usr/bin/ln,/usr/bin/hostnamectl,/usr/bin/rpm,/usr/bin/yum,\
/usr/bin/pkill,/usr/bin/grep,/usr/sbin/setenforce,/usr/sbin/sysctl,/usr/bin/mv,/usr/bin/tar,/usr/bin/pip3,\
${THIRD_DIR}/zzyoss/zc,/usr/bin/java,/usr/bin/dpkg"
		sed -i "/^root.*ALL=(ALL.*).*ALL/a ${user_name}\tALL=(ALL)\tNOPASSWD: ${cmd_str}\t" /etc/sudoers
	;;
	2)
		cmd_str="/usr/sbin/iptables,/usr/sbin/gluster,/usr/sbin/exportfs,/usr/sbin/showmount,/usr/bin/mount,\
/usr/bin/umount,/usr/bin/systemctl,/usr/bin/sed,/usr/bin/tee,/usr/bin/vi,/usr/bin/mkdir,/usr/bin/cp,\
/usr/bin/rm,/usr/bin/chown,/usr/bin/chmod,/usr/bin/ln,/usr/bin/hostnamectl,/usr/bin/rpm,/usr/bin/yum,\
/usr/bin/pkill,/usr/bin/grep,/usr/sbin/setenforce,/usr/sbin/sysctl,/usr/bin/mv,/usr/bin/tar,/usr/bin/pip3,\
${THIRD_DIR}/zzyoss/zc,/usr/bin/java,/usr/bin/dpkg"
		sed -i "/^root.*ALL=(ALL.*).*ALL/a ${user_name}\tALL=(ALL)\tNOPASSWD: ${cmd_str}\t" /etc/sudoers
	;;
	3)
		cmd_str="/usr/sbin/iptables,/usr/sbin/exportfs,/usr/sbin/showmount,/usr/bin/mount,\
/usr/bin/umount,/usr/bin/systemctl,/usr/bin/sed,/usr/bin/tee,/usr/bin/vi,/usr/bin/mkdir,/usr/bin/cp,\
/usr/bin/rm,/usr/bin/chown,/usr/bin/chmod,/usr/bin/ln,/usr/bin/hostnamectl,/usr/bin/rpm,/usr/bin/yum,\
/usr/bin/pkill,/usr/bin/grep,/usr/sbin/setenforce,/usr/sbin/sysctl,/usr/bin/mv,/usr/bin/tar,\
${THIRD_DIR}/zzyoss/zc,${THIRD_DIR}/ntp/ntpdate,${THIRD_DIR}/ntp/ntpd,${THIRD_DIR}/ntp/ntpq,/usr/bin/java,/usr/bin/dpkg,/usr/sbin/ldconfig,/usr/bin/timedatectl"	
		sed -i "/^root.*ALL=(ALL.*).*ALL/a ${user_name}\tALL=(ALL)\tNOPASSWD: ${cmd_str}\t" /etc/sudoers
	;;
	*)
		echo "usage : 参数不对"
	esac
}
function sdp_ssh(){
	case $version in
	1)
		sed -i "/^root.*ALL=(ALL.*).*ALL/a ${user_name}\tALL=(ALL)\tNOPASSWD: ALL\t" /etc/sudoers
		sed -i "s%IS_CHECK_SUDO=1%IS_CHECK_SUDO=0%" config/zzyenv.ini
	;;
	2)
		cmd_str="/usr/sbin/iptables,/usr/bin/systemctl,/usr/bin/sed,/usr/bin/tee,/usr/bin/vi,/usr/bin/mkdir,\
/usr/bin/rm,/usr/bin/chown,/usr/bin/chmod,/usr/bin/ln,/usr/bin/hostnamectl,/usr/bin/rpm,/usr/bin/yum,\
/usr/bin/pkill,/usr/bin/grep,/usr/sbin/setenforce,/usr/sbin/sysctl,/usr/bin/mv,/usr/bin/tar,/usr/bin/su,\
/usr/bin/pip3,/usr/bin/kill,/usr/bin/touch,/usr/sbin/lsmod,/usr/sbin/ip,/usr/sbin/rmmod,/usr/bin/cp,\
/sbin/modprobe,/usr/bin/chgrp,/usr/sbin/ip6tables,/usr/sbin/ipset,/usr/local/openresty/nginx/sbin/nginx,\
/usr/bin/java,/usr/bin/dpkg,/usr/bin/more,${THIRD_DIR}/unbound/sbin/unbound-control,/usr/sbin/ip6tables-restore,\
/usr/bin/echo,/usr/sbin/ldconfig,/usr/bin/lscpu,/usr/bin/cat,/usr/bin/md5sum,/usr/sbin/virt-what,\
/usr/bin/timedatectl,/usr/sbin/insmod,/usr/sbin/iptables-restore,/usr/bin/ps,/usr/local/guacamole/sbin/guacd,\
${PRODUCT_SDP_DIR}/usdp-gateway/bin/usdp.bash,${PRODUCT_SDP_DIR}/usdp-gateway/bin/ugw"		
		sed -i "/^root.*ALL=(ALL.*).*ALL/a ${user_name}\tALL=(ALL)\tNOPASSWD: ${cmd_str}\t" /etc/sudoers
	;;
	3)
		cmd_str="/usr/sbin/iptables,/usr/bin/systemctl,/usr/bin/sed,/usr/bin/tee,/usr/bin/vi,/usr/bin/mkdir,\
/usr/bin/rm,/usr/bin/chown,/usr/bin/chmod,/usr/bin/ln,/usr/bin/hostnamectl,/usr/bin/rpm,/usr/bin/yum,\
/usr/bin/pkill,/usr/bin/grep,/usr/sbin/setenforce,/usr/sbin/sysctl,/usr/bin/mv,/usr/bin/tar,/usr/bin/su,\
/usr/bin/kill,/usr/bin/touch,/usr/sbin/lsmod,/usr/sbin/ip,/usr/sbin/rmmod,/usr/bin/cp,\
/sbin/modprobe,/usr/bin/chgrp,/usr/sbin/ip6tables,/usr/sbin/ipset,/usr/local/openresty/nginx/sbin/nginx,\
/usr/bin/java,/usr/bin/dpkg,/usr/bin/more,${THIRD_DIR}/unbound/sbin/unbound-control,/usr/sbin/ip6tables-restore,\
/usr/sbin/ldconfig,/usr/bin/lscpu,/usr/bin/cat,/usr/bin/md5sum,/usr/sbin/virt-what,\
/usr/bin/timedatectl,/usr/sbin/insmod,/usr/sbin/iptables-restore,/usr/bin/ps,/usr/local/guacamole/sbin/guacd,\
${PRODUCT_SDP_DIR}/usdp-gateway/bin/usdp.bash,${PRODUCT_SDP_DIR}/usdp-gateway/bin/ugw,${THIRD_DIR}/ntp/ntpdate,${THIRD_DIR}/ntp/ntpd,\
${THIRD_DIR}/ntp/ntpq,${PRODUCT_SDP_DIR}/usdp-waf-engine/usdp-waf-engine.sh,${PRODUCT_SDP_DIR}/usdp-waf-engine/usdp-waf-engine-stream.sh"
		sed -i "/^root.*ALL=(ALL.*).*ALL/a ${user_name}\tALL=(ALL)\tNOPASSWD: ${cmd_str}\t" /etc/sudoers
	;;
	*)
		echo "usage : 参数不对"
	esac
}

function su_user(){
    curl -o /opt/public.key http://down-n.zhizhangyi.com/basenv/v5/public.key &>/dev/null
    su "$1" -c "
        cd /opt
        sudo chown -R $1:$1 .
        
        # 导入密钥
        gpg --import public.key &>/dev/null
        if [[ $? -eq 0 ]]; then
            echo '导入密钥成功！'
        else
            echo '导入密钥失败！'
        fi

        # 检查并解密 zzyenv-*.asc 文件
        if ls zzyenv-*.asc &>/dev/null; then
            echo '解密中....'
            gpg --output zzyenv.tar.gz --decrypt zzyenv-*.asc &>/dev/null
            if [[ $? -eq 0 ]]; then
                echo '解密成功！'
            else
                echo '解密失败！'
            fi
	    echo '开始解压基础环境包...'
            tar zxf zzyenv.tar.gz
        else
            echo '没有找到 zzyenv 文件'
        fi

        # 根据用户检查并解压相应的 tar 文件
        if [[ \"$1\" == 'mbs' ]]; then
            if ls mbs*.tar.gz &>/dev/null; then
		echo '开始解压产品包...'
                tar zxf mbs*.tar.gz
            else
                echo '没有找到 mbs tar 文件。'
            fi
        else
            if ls usdp*.tar.gz &>/dev/null; then
		echo '开始解压产品包'
                tar zxf usdp*.tar.gz
            else
                echo '没有找到 sdp tar 文件。'
            fi
        fi
    "
}
